//
//  Utilities.h
//  ConvexHull2d
//
//  Created by kumada on 2013/06/06.
//  Copyright (c) 2013年 kumada. All rights reserved.
//

#ifndef __ConvexHull2d__Utilities__
#define __ConvexHull2d__Utilities__

#include <vector>
#include <iostream>
#include <memory>
#include "Point.h"

class Debug
{
public:
        template<typename T>
        static bool see_vertices(
                const std::vector<int>& vertices,
                const std::vector<std::unique_ptr<geo::Point<T, geo::TwoDimension>>>& points,
                const std::vector<int>& names
        ) {
                int first = search_living_vertex(vertices);
                int i = first;
                std::cout << "[" << i << "]" << points[names[i]]->at(0) << ", " << points[names[i]]->at(1) << std::endl;
                while ( true ) {
                        
                        int index = vertices[i];
                        const auto& p = points[names[index]];
                        std::cout << "[" << index << "]" << p->at(0) << ", " << p->at(1) << std::endl;
                        i = index;
                        if ( i == first ) {
                                break;
                        }
                }
                std::cout << "===\n";
                return true;
        }

        static int search_living_vertex(const std::vector<int>& vertices);
};

#ifdef DEBUG
        #define DEBUG_SEE_VERTICES(t,x,y,z) Debug::see_vertices<t>(x,y,z)
#else  // DEBUG
        #define DEBUG_SEE_VERTICES(t,x,y,z)
#endif // DEBUG

#endif /* defined(__ConvexHull2d__Utilities__) */
